HDU - 1506 Largest Rectangle in a Histogram

Largest Rectangle in a Histogram

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 19158    Accepted Submission(s): 5761


Problem Description
A histogram is a polygon composed of a sequence of rectangles aligned at a common base line. The rectangles have equal widths but may have different heights. For example, the figure on the left shows the histogram that consists of rectangles with the heights 2, 1, 4, 5, 1, 3, 3, measured in units where 1 is the width of the rectangles:

Usually, histograms are used to represent discrete distributions, e.g., the frequencies of characters in texts. Note that the order of the rectangles, i.e., their heights, is important. Calculate the area of the largest rectangle in a histogram that is aligned at the common base line, too. The figure on the right shows the largest aligned rectangle for the depicted histogram.
 

Input
The input contains several test cases. Each test case describes a histogram and starts with an integer n, denoting the number of rectangles it is composed of. You may assume that 1 <= n <= 100000. Then follow n integers h1, ..., hn, where 0 <= hi <= 1000000000. These numbers denote the heights of the rectangles of the histogram in left-to-right order. The width of each rectangle is 1. A zero follows the input for the last test case.
 

Output
For each test case output on a single line the area of the largest rectangle in the specified histogram. Remember that this rectangle must be aligned at the common base line.
 

Sample Input

7 2 1 4 5 1 3 3 4 1000 1000 1000 1000 0
 

Sample Output

8 4000
 
基本思路:
       遍历数组,以i点为当前序列的最低点,向两边扩展,显然只能扩展比i点高的点。
然而如果不用任何优化,直接dp的话肯定超时。所以我们用了两个数组L[],R[]来记录i点为最低点时序列的左右边界下标。显然,如果a[i]<=a[j-1](j为左边界的下标),那么j肯定可以扩展到L[j-1],因为是单调递增序列。同理可以求出右边界。这样就减掉了许多多余的遍历。
代码:
#include
#include
#include
#include
using namespace std;
#define inf 1<<29
long long a[100005],r[100005],l[100005];
int main()
{
    int n;
    while(~scanf("%d",&n) && n)
    {
        for(int i=0;i0 && a[i]<=a[j-1]) j=l[j-1];
            l[i]=j;
        }
        for(int i=n-2;i>=0;i--)
        {
            int j=i;
            while(j


你可能感兴趣的:(动态规划,数据结构~单调栈/队列)